/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BUTTON_H_
#define BUTTON_H_

/**
 * Click types
 */
typedef enum {
    CT_1T       = 0,    /**< Tip 1 */
    CT_2T       = 1,    /**< Tip 2 */
    CT_3T       = 2,    /**< Tip 3 */
    CT_4T       = 3,    /**< Tip 4 */
    CT_HS       = 4,    /**< Hold start */
    CT_HR       = 5,    /**< Hold repeat */
    CT_HE       = 6,    /**< Hold end */
    CT_1C       = 7,    /**< Short click */
    CT_2C       = 8,    /**< Double click */
    CT_3C       = 9,    /**< Triple click */
    CT_1P       = 10,   /**< Short-long program click */
    CT_L0       = 11,   /**< Local button tip: Device is now off */
    CT_L1       = 12,   /**< Local button tip: Device is now on */
    CT_2P       = 13,   /**< Local programming mode */
    CT_LS       = 14,   /**< Local stop */
} ButtonClickType;

typedef enum {
    BUTTON_LOCAL = 0,
    BUTTON_GROUP_1,
    BUTTON_GROUP_2,
    BUTTON_GROUP_3,
    BUTTON_GROUP_4,
    BUTTON_ZONE_0,
    BUTTON_ZONE_1,
    BUTTON_ZONE_2,
    BUTTON_ZONE_3,
    BUTTON_ZONE_4,
    BUTTON_GROUP_5,
    BUTTON_GROUP_6,
    BUTTON_GROUP_7,
    BUTTON_GROUP_8,
    BUTTON_APARTMENT,
    BUTTON_SERVER,
    BUTTON_LAST,
} ButtonId;

typedef enum {
    JOKER_BUTTON_ALARM = 1,
    JOKER_BUTTON_PANIC = 2,
    JOKER_BUTTON_LEAVEHOME = 3,
    JOKER_BUTTON_DOORBELL = 5,
} JokerButtonId;

typedef enum {
    KEY_1WAY = 0,
    KEY_2WAY_A = 1,
    KEY_2WAY_B = 2,
    KEY_LOCAL = 4,
    KEY_LOCAL_2WAY_A = 5,
    KEY_LOCAL_2WAY_B = 6,
} KeyId;

typedef enum {
    Sensor_SensorEvent = 0,
    Sensor_SensorPollRequest = 1,
    Sensor_StatusEvent = 2,
    Sensor_StatusPollRequest = 3,
    Sensor_BinaryInputEvent = 4,
} SensorEventType;

#endif /* BUTTON_H_ */
