/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SECURITY_H_
#define SECURITY_H_

#include "qp_port.h"
#include "scene.h"

typedef struct SecurityTag {
    QHsm super;
    QActive * parent;
    struct SharedOpTimeEvtTag *opTimer1;
    struct SharedOpTimeEvtTag *opTimer2;
    uint16_t fid;
    uint16_t deviceId;
    uint8_t localZoneId;
    uint8_t groupId;
    uint8_t key;
    Scene scene;
} Security;

void Security_ctor(Security *me);

#define Security_init(me_)             QHsm_init((QHsm *)(me_), (QEvent *)0)
#define Security_dispatch(me_, e_)     QHsm_dispatch((QHsm *)(me_), e_)

#endif /* SECURITY_H_ */
